//    Demo 6b: ObjectBubSort.java

//  A class containing a simple bubble sort method for arrays of objects 
//  implementing the LinearlyOrdered interface.
//
//                by Charles W. Neville, 1998
//             Copyright Charles W. Neville, 1998
//
//  We have to redo the bubble sort method from Demo 5, SimpleBubSort.java, by 
//  replacing every occurrence of ">" by "gt".
//

import LinearlyOrdered;

//  a class containing a bubble sort method for arrays of objects implementing 
//  the LinearlyOrdered interface.
public class ObjectBubSort {

   // bubble sort method for arrays of objects.
   // make it static so we don't have to create an ObjectBubSort object just to 
   // call the method.
   public static void bubSort(LinearlyOrdered[] a) {

      // note in the above how an interface name can be used in place of an 
      // object name, so the method can deal with ALL objects from classes 
      // implementing the LinearlyOrdered interface.  Otherwise, this is just 
      // bubble sort with ">" replaced by "gt".

      LinearlyOrdered temp;

      // an array of length 1 is automatically sorted, 
      // so only sort arrays of length > 1
      if (a.length > 1) {
        // actual bubble sort routine
        for (int i = a.length - 1; i > 0; i--) {
           for (int j = 1; j <= i; j++) {
              if ( a[j - 1].gt(a[j]) ) {
                 // swap a[j - 1] and a[j]
                 temp = a[j - 1];
                 a[j - 1] = a[j];
                 a[j] = temp;
              }
           }
         }
      }

   } // bubSort

} // class ObjectBubSort


   